-- NX錾
GreenBee = {}

-- ÓIoϐ
GreenBee.m_iImage = {}
GreenBee.m_iImage.normal = {}
GreenBee.m_iImage.damaged = {}

-- ÓIo֐
GreenBee.LoadImg = function()
	GreenBee.m_iImage.normal[ 0 ] = DerivationGraph( 0xC0, 0x20, 0x20, 0x20, unionImage.normal[ 0 ] )
	GreenBee.m_iImage.normal[ 1 ] = DerivationGraph( 0xE0, 0x20, 0x20, 0x20, unionImage.normal[ 0 ] )
	GreenBee.m_iImage.damaged[ 0 ] = DerivationGraph( 0xC0, 0x20, 0x20, 0x20, unionImage.damaged[ 0 ] )
	GreenBee.m_iImage.damaged[ 1 ] = DerivationGraph( 0xE0, 0x20, 0x20, 0x20, unionImage.damaged[ 0 ] )
end

-- ÓIo萔
GreenBee.A = {}			-- x
GreenBee.A.X = 0.08		-- x X
GreenBee.A.Y = 0.05		-- x Y
GreenBee.V_MAX = {}		-- ōx
GreenBee.V_MAX.X = 3.0	-- ōx X
GreenBee.V_MAX.Y = 1.5	-- ōx Y
GreenBee.SIZE = 20		-- 傫
GreenBee.LIFE_MAX = 1	-- Ct
GreenBee.COUNT_DENOMINATOR = 4	-- JEg̕
GreenBee.COUNT_MAX = GreenBee.COUNT_DENOMINATOR * 2

-- new
GreenBee.new = function( pointer, x, y )
	local obj = {}
	obj.cPointer = pointer
	obj.count = 0					-- t[JE^
	obj.pos = {}					-- W
	obj.pos.x = x					-- W X
	obj.pos.y = y					-- W Y
	obj.v = {}						-- x
	obj.v.x = 0						-- x X
	obj.v.y = 0						-- x Y
	obj.life = GreenBee.LIFE_MAX	-- Ct
	obj.m_iIsReuse = 0				-- ďo邩ۂ 0ȂĐ
	
	SetPos( pointer, x, y )
	SetShape( pointer, -GreenBee.SIZE / 2, -GreenBee.SIZE / 2, GreenBee.SIZE / 2, GreenBee.SIZE / 2 )
	
	function obj:Move()
		local PLAYER_POS = {}
		PLAYER_POS.X, PLAYER_POS.Y = GetPlayerPos()
		
		-- xvZ
		-- 
		if self.pos.x < PLAYER_POS.X then
			self.v.x = self.v.x + GreenBee.A.X
		else
			self.v.x = self.v.x - GreenBee.A.X
		end
		
		if self.pos.y < PLAYER_POS.Y then
			self.v.y = self.v.y + GreenBee.A.Y
		else
			self.v.y = self.v.y - GreenBee.A.Y
		end
		
		-- ōx
		if self.v.x < -1 * GreenBee.V_MAX.X then
			self.v.x = -1 * GreenBee.V_MAX.X
		end
		
		if GreenBee.V_MAX.X < self.v.x then
			self.v.x = GreenBee.V_MAX.X
		end
		
		if self.v.y < -1 * GreenBee.V_MAX.Y then
			self.v.y = -1 * GreenBee.V_MAX.Y
		end
		
		if GreenBee.V_MAX.Y < self.v.y then
			self.v.y = GreenBee.V_MAX.Y
		end
		
		-- ړ
		self.pos.x = self.pos.x + self.v.x
		self.pos.y = self.pos.y + self.v.y
		
		-- SetPos
		SetPos( self.cPointer, self.pos.x, self.pos.y )
		SetDirection( self.cPointer, self.v.x < 0 )
		SetAnimIndex( self.cPointer, GreenBee.m_iImage.normal[ 0 ] )
		
		--return self;
	end
	
	function obj:Draw()
		local origin_x, origin_y = GetOrigin()
		local r
		
		if 0 < self.v.x then
			r = DrawGraph( self.pos.x - origin_x - 16, self.pos.y - origin_y - 16, GreenBee.m_iImage.normal[ math.floor( self.count / GreenBee.COUNT_DENOMINATOR ) ], 1 )
		else
			r = DrawTurnGraph( self.pos.x - origin_x - 16, self.pos.y - origin_y - 16, GreenBee.m_iImage.normal[ math.floor( self.count / GreenBee.COUNT_DENOMINATOR ) ], 1 )
		end
		
		self.count = self.count + 1
		
		if self.count == GreenBee.COUNT_MAX then
			self.count = 0
		end
		
		return r;
	end
	
	return obj;
end
