-- NX錾
EndingBee = {}

-- ÓIoϐ
EndingBee.m_iImage = {}

-- ÓIo֐
EndingBee.LoadImg = function()
	EndingBee.m_iImage[ 0 ] = DerivationGraph( 0x00, 0x20, 0x20, 0x20, unionImage.normal[ 0 ] )
	EndingBee.m_iImage[ 1 ] = DerivationGraph( 0x20, 0x20, 0x20, 0x20, unionImage.normal[ 0 ] )
end

-- ÓIo萔
EndingBee.V = 2.5								-- x
EndingBee.LIFE_MAX = 1							-- Ct
EndingBee.TIME_WAIT = 75						-- Xgbv
EndingBee.TIME_GO = 75 + EndingBee.TIME_WAIT	-- is
EndingBee.COUNT_MAX = 10
EndingBee.COUNT_DENOMINATOR = 5
EndingBee.COUNT_MAX = EndingBee.COUNT_DENOMINATOR * 2

-- new
EndingBee.new = function( pointer, x, y )
	local obj = {}
	obj.pos = {}	-- W
	obj.pos.x = x	-- W X
	obj.pos.y = y	-- W Y
	obj.angle = 0	-- px
	obj.av = 0		-- px
	obj.count = 0
	
	SetPos( pointer, x, y )
	SetShape( pointer, 0, 0, 0, 0 )
	
	function obj:MoveWait()
		self.count = self.count + 1
	end
	
	function obj:MoveGo()
		if self.count == EndingBee.TIME_WAIT then
			self.angle = self.angle + self.av
		end
		self.pos.x = self.pos.x + EndingBee.V * math.cos( self.angle )
		self.pos.y = self.pos.y + EndingBee.V * math.sin( self.angle )
		self.count = self.count + 1
	end
	
	function obj:Move()
		-- ړ
		if self.count < EndingBee.TIME_WAIT then
			self:MoveWait()
		elseif self.count < EndingBee.TIME_GO then
			self:MoveGo()
		end
		
		-- JE^Zbg
		if self.count == EndingBee.TIME_GO then
			self.count = 0
		end
	end
	
	function obj:Draw()
		local origin_x, origin_y = GetOrigin()
		local x = self.pos.x - origin_x - 16
		local y = self.pos.y - origin_y - 16
		if 0 < math.cos( self.angle ) then
			DrawGraph( x, y, EndingBee.m_iImage[ math.floor( self.count / EndingBee.COUNT_DENOMINATOR ) % 2 ], 1 )
		else
			DrawTurnGraph( x, y, EndingBee.m_iImage[ math.floor( self.count / EndingBee.COUNT_DENOMINATOR ) % 2 ], 1 )
		end
		
		return 0
	end
	
	return obj
end

EndingBeeA = {}
EndingBeeA.IA = 1 - 2	-- px
EndingBeeA.AV = 2	-- px
EndingBeeA.LIFE_MAX = EndingBee.LIFE_MAX
EndingBeeA.new = function( pointer, x, y )
	local obj = EndingBee.new( pointer, x, y )
	obj.angle = EndingBeeA.IA
	obj.av = EndingBeeA.AV
	obj.count = 0
	
	return obj
end

EndingBeeB = {}
EndingBeeB.IA = 3 - 2	-- px
EndingBeeB.AV = 2.2	-- px
EndingBeeB.LIFE_MAX = EndingBee.LIFE_MAX
EndingBeeB.new = function( pointer, x, y )
	local obj = EndingBee.new( pointer, x, y )
	obj.angle = EndingBeeB.IA
	obj.av = EndingBeeB.AV
	obj.count = 0
	
	return obj
end

EndingBeeC = {}
EndingBeeC.IA = 5 - 2	-- px
EndingBeeC.AV = 2.4	-- px
EndingBeeC.LIFE_MAX = EndingBee.LIFE_MAX
EndingBeeC.new = function( pointer, x, y )
	local obj = EndingBee.new( pointer, x, y )
	obj.angle = EndingBeeC.IA
	obj.av = EndingBeeC.AV
	obj.count = 0
	
	return obj
end