-- クラス定義
bee = {}
-- 定数定義
bee.INTERVAL_MIN = 400;
bee.INTERVAL_MAX = 500;

-- 変数定義
beeflag = false;--false,	-- 無限湧きを行うか否かのフラグ
bee.count = math.random(bee.INTERVAL_MIN, bee.INTERVAL_MAX);		-- フレームカウンタ

-- メソッド定義
-- C言語側の敵生成関数を呼び出す関数
bee.New = function( x, y )
	Enemy( "ENEMY_TYPE_BEE", x, y );
end
-- 敵の出現する場所を無作為に決定する関数
bee.Search = function ()
	-- 画面左上座標を取得
	local origin = {}
	origin.x = 0;
	origin.y = 0;
	
	
	origin.x, origin.y = GetOrigin();
	
	-- 開始位置をランダムに取得
	local x = math.random( 0, 1 );
	if x == 0 then
		x = origin.x - 16;
	else
		x = origin.x + 640 + 16;
	end
	local y = origin.y + math.random( 48, 480 - 112 );
	
	return x, y;
	--[[ 
	-- 過去のコード
	-- 出現位置を決定
	-- local y = 0;
	chip = GetCollisionType( origin.x / 32 - 1 + start.x * 22, origin.y / 32 + ( start.y + y ) % 16;
	--]]
	
end
-- 毎フレーム実行する関数
bee.Do = function ()
	if (beeflag == false) then
		return;
	end
	if (bee.count == 0) then
		local x, y;
		x, y = bee.Search();
		bee.New( x, y );
		bee.count = math.random(bee.INTERVAL_MIN, bee.INTERVAL_MAX);
	else
		bee.count = bee.count - 1;
	end
end
